Index: pacemaker/pengine/test10/clone_min_stop_all.exp
===================================================================
--- pacemaker.orig/pengine/test10/clone_min_stop_all.exp
+++ pacemaker/pengine/test10/clone_min_stop_all.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="10" operation="monitor" operation_key="shooter_monitor_60000" on_node="c7auto4" on_node_uuid="4">
         <primitive id="shooter" class="stonith" type="fence_phd_kvm"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="c7auto4" CRM_meta_on_node_uuid="4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="9" operation="start" operation_key="shooter_start_0" on_node="c7auto4" on_node_uuid="4">
         <primitive id="shooter" class="stonith" type="fence_phd_kvm"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="c7auto4" CRM_meta_on_node_uuid="4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="8" operation="stop" operation_key="shooter_stop_0" on_node="c7auto1" on_node_uuid="1">
         <primitive id="shooter" class="stonith" type="fence_phd_kvm"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="c7auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="11" operation="stop" operation_key="FAKECLONE_stop_0" internal_operation_key="FAKECLONE:0_stop_0" on_node="c7auto1" on_node_uuid="1">
         <primitive id="FAKECLONE" long-id="FAKECLONE:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="c7auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -51,7 +51,7 @@
     <action_set>
       <rsc_op id="12" operation="stop" operation_key="FAKECLONE_stop_0" internal_operation_key="FAKECLONE:1_stop_0" on_node="c7auto2" on_node_uuid="2">
         <primitive id="FAKECLONE" long-id="FAKECLONE:1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="c7auto2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -64,7 +64,7 @@
     <action_set>
       <rsc_op id="13" operation="stop" operation_key="FAKECLONE_stop_0" internal_operation_key="FAKECLONE:2_stop_0" on_node="c7auto3" on_node_uuid="3">
         <primitive id="FAKECLONE" long-id="FAKECLONE:2" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="c7auto3" CRM_meta_on_node_uuid="3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -110,7 +110,7 @@
     <action_set>
       <rsc_op id="18" operation="stop" operation_key="FAKE_stop_0" on_node="c7auto4" on_node_uuid="4">
         <primitive id="FAKE" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="c7auto4" CRM_meta_on_node_uuid="4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/clone_min_stop_one.exp
===================================================================
--- pacemaker.orig/pengine/test10/clone_min_stop_one.exp
+++ pacemaker/pengine/test10/clone_min_stop_one.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="12" operation="stop" operation_key="FAKECLONE_stop_0" internal_operation_key="FAKECLONE:1_stop_0" on_node="c7auto2" on_node_uuid="2">
         <primitive id="FAKECLONE" long-id="FAKECLONE:1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="c7auto2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/clone_min_stop_two.exp
===================================================================
--- pacemaker.orig/pengine/test10/clone_min_stop_two.exp
+++ pacemaker/pengine/test10/clone_min_stop_two.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="10" operation="monitor" operation_key="shooter_monitor_60000" on_node="c7auto3" on_node_uuid="3">
         <primitive id="shooter" class="stonith" type="fence_phd_kvm"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="c7auto3" CRM_meta_on_node_uuid="3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="9" operation="start" operation_key="shooter_start_0" on_node="c7auto3" on_node_uuid="3">
         <primitive id="shooter" class="stonith" type="fence_phd_kvm"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="c7auto3" CRM_meta_on_node_uuid="3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="8" operation="stop" operation_key="shooter_stop_0" on_node="c7auto1" on_node_uuid="1">
         <primitive id="shooter" class="stonith" type="fence_phd_kvm"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="c7auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="11" operation="stop" operation_key="FAKECLONE_stop_0" internal_operation_key="FAKECLONE:0_stop_0" on_node="c7auto1" on_node_uuid="1">
         <primitive id="FAKECLONE" long-id="FAKECLONE:0" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="c7auto1" CRM_meta_on_node_uuid="1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -51,7 +51,7 @@
     <action_set>
       <rsc_op id="12" operation="stop" operation_key="FAKECLONE_stop_0" internal_operation_key="FAKECLONE:1_stop_0" on_node="c7auto2" on_node_uuid="2">
         <primitive id="FAKECLONE" long-id="FAKECLONE:1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_node="c7auto2" CRM_meta_on_node_uuid="2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -118,7 +118,7 @@
     <action_set>
       <rsc_op id="19" operation="stop" operation_key="FAKE_stop_0" on_node="c7auto4" on_node_uuid="4">
         <primitive id="FAKE" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="c7auto4" CRM_meta_on_node_uuid="4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/cloned-group-stop.exp
===================================================================
--- pacemaker.orig/pengine/test10/cloned-group-stop.exp
+++ pacemaker/pengine/test10/cloned-group-stop.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="34" operation="stop" operation_key="qpidd_stop_0" internal_operation_key="qpidd:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="qpidd" long-id="qpidd:0" class="lsb" type="qpidd"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="35" operation="stop" operation_key="qpidd_stop_0" internal_operation_key="qpidd:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="qpidd" long-id="qpidd:1" class="lsb" type="qpidd"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -59,7 +59,7 @@
     <action_set>
       <rsc_op id="40" operation="stop" operation_key="keystone_stop_0" internal_operation_key="keystone:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="keystone" long-id="keystone:0" class="lsb" type="openstack-keystone"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -72,7 +72,7 @@
     <action_set>
       <rsc_op id="42" operation="stop" operation_key="keystone_stop_0" internal_operation_key="keystone:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="keystone" long-id="keystone:1" class="lsb" type="openstack-keystone"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -148,7 +148,7 @@
     <action_set>
       <rsc_op id="48" operation="stop" operation_key="glance-fs_stop_0" internal_operation_key="glance-fs:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="glance-fs" long-id="glance-fs:0" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  device="192.168.0.2:/srv/vms/clusters/nfs-storage/glance" directory="/var/lib/glance/" fstype="nfs" options="v3"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000"  device="192.168.0.2:/srv/vms/clusters/nfs-storage/glance" directory="/var/lib/glance/" fstype="nfs" options="v3"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -164,7 +164,7 @@
     <action_set>
       <rsc_op id="50" operation="stop" operation_key="glance-registry_stop_0" internal_operation_key="glance-registry:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="glance-registry" long-id="glance-registry:0" class="lsb" type="openstack-glance-registry"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -180,7 +180,7 @@
     <action_set>
       <rsc_op id="52" operation="stop" operation_key="glance-api_stop_0" internal_operation_key="glance-api:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="glance-api" long-id="glance-api:0" class="lsb" type="openstack-glance-api"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -226,7 +226,7 @@
     <action_set>
       <rsc_op id="58" operation="stop" operation_key="glance-fs_stop_0" internal_operation_key="glance-fs:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="glance-fs" long-id="glance-fs:1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000"  device="192.168.0.2:/srv/vms/clusters/nfs-storage/glance" directory="/var/lib/glance/" fstype="nfs" options="v3"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000"  device="192.168.0.2:/srv/vms/clusters/nfs-storage/glance" directory="/var/lib/glance/" fstype="nfs" options="v3"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -242,7 +242,7 @@
     <action_set>
       <rsc_op id="60" operation="stop" operation_key="glance-registry_stop_0" internal_operation_key="glance-registry:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="glance-registry" long-id="glance-registry:1" class="lsb" type="openstack-glance-registry"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -258,7 +258,7 @@
     <action_set>
       <rsc_op id="62" operation="stop" operation_key="glance-api_stop_0" internal_operation_key="glance-api:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="glance-api" long-id="glance-api:1" class="lsb" type="openstack-glance-api"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -334,7 +334,7 @@
     <action_set>
       <rsc_op id="72" operation="stop" operation_key="cinder-api_stop_0" internal_operation_key="cinder-api:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="cinder-api" long-id="cinder-api:0" class="lsb" type="openstack-cinder-api"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -350,7 +350,7 @@
     <action_set>
       <rsc_op id="74" operation="stop" operation_key="cinder-scheduler_stop_0" internal_operation_key="cinder-scheduler:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="cinder-scheduler" long-id="cinder-scheduler:0" class="lsb" type="openstack-cinder-scheduler"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -366,7 +366,7 @@
     <action_set>
       <rsc_op id="76" operation="stop" operation_key="cinder-volume_stop_0" internal_operation_key="cinder-volume:0_stop_0" on_node="rhos4-node4" on_node_uuid="rhos4-node4">
         <primitive id="cinder-volume" long-id="cinder-volume:0" class="lsb" type="openstack-cinder-volume"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node4" CRM_meta_on_node_uuid="rhos4-node4" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -412,7 +412,7 @@
     <action_set>
       <rsc_op id="82" operation="stop" operation_key="cinder-api_stop_0" internal_operation_key="cinder-api:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="cinder-api" long-id="cinder-api:1" class="lsb" type="openstack-cinder-api"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -428,7 +428,7 @@
     <action_set>
       <rsc_op id="84" operation="stop" operation_key="cinder-scheduler_stop_0" internal_operation_key="cinder-scheduler:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="cinder-scheduler" long-id="cinder-scheduler:1" class="lsb" type="openstack-cinder-scheduler"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -444,7 +444,7 @@
     <action_set>
       <rsc_op id="86" operation="stop" operation_key="cinder-volume_stop_0" internal_operation_key="cinder-volume:1_stop_0" on_node="rhos4-node3" on_node_uuid="rhos4-node3">
         <primitive id="cinder-volume" long-id="cinder-volume:1" class="lsb" type="openstack-cinder-volume"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="rhos4-node3" CRM_meta_on_node_uuid="rhos4-node3" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/cloned-group.exp
===================================================================
--- pacemaker.orig/pengine/test10/cloned-group.exp
+++ pacemaker/pengine/test10/cloned-group.exp
@@ -66,7 +66,7 @@
      <action_set>
       <rsc_op id="7" operation="stop" operation_key="apache2:1_stop_0" internal_operation_key="apache2:0_stop_0" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="apache2" long-id="apache2:1" class="ocf" provider="heartbeat" type="apache"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -82,7 +82,7 @@
      <action_set>
       <rsc_op id="6" operation="start" operation_key="apache2:1_start_0" internal_operation_key="apache2:0_start_0" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="apache2" long-id="apache2:1" class="ocf" provider="heartbeat" type="apache"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -98,7 +98,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="apache2:1_monitor_10000" internal_operation_key="apache2:0_monitor_10000" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="apache2" long-id="apache2:1" class="ocf" provider="heartbeat" type="apache"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -111,7 +111,7 @@
      <action_set>
       <rsc_op id="9" operation="start" operation_key="mysql-proxy:1_start_0" internal_operation_key="mysql-proxy:0_start_0" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="mysql-proxy" long-id="mysql-proxy:1" class="lsb" type="mysql-proxy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -130,7 +130,7 @@
      <action_set>
       <rsc_op id="8" operation="stop" operation_key="mysql-proxy:1_stop_0" internal_operation_key="mysql-proxy:0_stop_0" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="mysql-proxy" long-id="mysql-proxy:1" class="lsb" type="mysql-proxy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -143,7 +143,7 @@
      <action_set>
       <rsc_op id="1" operation="monitor" operation_key="mysql-proxy:1_monitor_10000" internal_operation_key="mysql-proxy:0_monitor_10000" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="mysql-proxy" long-id="mysql-proxy:1" class="lsb" type="mysql-proxy"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -186,7 +186,7 @@
      <action_set>
       <rsc_op id="18" operation="stop" operation_key="apache2:0_stop_0" internal_operation_key="apache2:2_stop_0" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="apache2:0" long-id="apache2:2" class="ocf" provider="heartbeat" type="apache"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" configfile="/etc/apache2/apache2.conf"  httpd="/usr/sbin/apache2" options="-k start" target_role="started"/>
        </rsc_op>
      </action_set>
      <inputs>
@@ -202,7 +202,7 @@
      <action_set>
       <rsc_op id="19" operation="stop" operation_key="mysql-proxy:0_stop_0" internal_operation_key="mysql-proxy:2_stop_0" on_node="webcluster01" on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298">
         <primitive id="mysql-proxy:0" long-id="mysql-proxy:2" class="lsb" type="mysql-proxy"/>
-        <attributes CRM_meta_clone="2" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="2" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_on_node="webcluster01" CRM_meta_on_node_uuid="49e81295-8e2f-4aeb-98f3-a14de6f62298" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
